# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl Macrame.t'

#########################
BEGIN { print STDERR "IN  TEST SCRIPT\n"}
# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More qw/no_plan/; # tests => 3;
# BEGIN { use_ok('Macrame') };
use Macrame;
BEGIN{ pass('file loaded OK')};
my $fish = { salmon => 'pink', quant => 700 };
#macro MYPASS(expl){pass('expl');}
#MYPASS(this_should_pass)
is($fish->{salmon} , 'pink', "unmunged ");

no Macrame;

ok(!0, 'still going after no');



#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.


use Macrame;

macro foo { warn "incrementing to ".++$x::x."\n"; }

warn "there is a comment\n"; #after this line
# there is a house, in new orleans # it's called the rising sun
# ooh nasty -- a single quotemark in a comment fools the
# parser in Filter::Simple ' there is the match for it

foo; foo; foo;

is($x::x, 3, 'ran foo macro three times');
no Macrame;
sub foo(){$x::yz++};
foo; foo;
is($x::x, 3, 'outside of macrame block macros not applied');
is($x::yz, 2, 'not applied at all');
use Macrame;
foo;
no Macrame;
is($x::x, 4, 'macros persist between Macrame blocks');


use Macrame;
macro setxx val {$x::x = val}
pass ('macro signature syntax no parens');

setxx '7';
is($x::x, 7, ' macro invocation quotelike argument');
setxx (27 + 4);
is($x::x, 31, ' macro invocation grouped argument');

macro  plusmeansminus left+right {left-right};
macro  plusmeansminus left @ right {left+right};
pass ('macro syntax including pynctuation');

is((37-30), (plusmeansminus (7 + 15 * 2) + 30), "syntax triggered sig");
is((37+30), (plusmeansminus (7 + 15 * 2) @ 30), "alternate syn trgrd sig");

no Macrame;
pass ('Whew!');


use constant HaveVariadicArgumentSyntax => 0;
HaveVariadicArgumentSyntax and eval <<'LAVE';
use Macrame;
macro pmacro name (sig) [body] {
   macro name sig {body}
   macro name (sig) {body}
}

pmacro X(a,b)[ ( (a) x (b) ) ]
is(X('A',4),'AAAA', "mac in mac 1 of 2");
is(X'A',4,'AAAA', "mac in mac 2 of 2");
no Macrame
LAVE


use Macrame;
is(3, 9 SLASH 3, "predefined SLASH macro");
macro  plusmeansminus left SLASH right {left+right};
pass ('macro in macro definition signature part');
is((37+30), (plusmeansminus (7 + 15 * 2) SLASH 30), "macro in sig");
eval {
	plusmeansminus (7 + 15 * 2) *  30
};
ok($@, "should have failed to match anything");
__END__


